;
;******************************************************************************
TITLE CONTROL - ControlDispatch for VSAuthD in C
;******************************************************************************
;
;  Copyright (C) 1995 Dallas Semiconductor Corporation.
;  All rights Reserved. Printed in U.S.A.
;  This software is protected by copyright laws of
;  the United States and of foreign countries.
;  This material may also be protected by patent laws of the United States
;  and of foreign countries.
;  This software is furnished under a license agreement and/or a
;  nondisclosure agreement and may only be used or copied in accordance
;  with the terms of those agreements.
;  The mere transfer of this software does not imply any licenses
;  of trade secrets, proprietary technology, copyrights, patents,
;  trademarks, maskwork rights, or any other form of intellectual
;  property whatsoever. Dallas Semiconductor retains all ownership rights.

;
;  This code was derived from the CVxD32 sample code in the Windows 95 DDK.
;

; $Workfile: VSCtrl.asm $
; $Revision: 3 $
; $Date: 12/21/98 1:21p $
; $Author: Tomc $
; $Modtime: 12/21/98 1:21p $
; $Log: /DOS Button/VSAuthD/VSCtrl.asm $
; 
; 3     12/21/98 1:21p Tomc

    .386p
;
;******************************************************************************
;                I N C L U D E S
;******************************************************************************

    .xlist
    include vmm.inc
;    include debug.inc
    .list

; a 1 in the following equate makes the VXD dynamically loadable.
  CVXDSAMP_DYNAMIC EQU 1

  VSAUTHD_DEVICE_ID   EQU Undefined_Device_ID;
;3C9Eh
ifdef _VXD_SERVICES
; ****** Define the VxD services that can be called from other VxDs
  Create_CVXD_Service_Table = 1

; The VxD services provided for other VxDs to call
  Begin_Service_Table CVXD
	 CVXD_Service     _CVXD_Get_Version, VxD_LOCKED_CODE
  End_Service_Table CVXD
endif

;============================================================================
;        V I R T U A L   D E V I C E   D E C L A R A T I O N
;============================================================================

DECLARE_VIRTUAL_DEVICE    VSAUTHD, 1, 0, CVXD_Control, VSAUTHD_DEVICE_ID, \
                              UNDEFINED_INIT_ORDER, VSAUTHD_VM , VSAUTHD_PM
;
VxD_LOCKED_CODE_SEG

ifdef _VXD_SERVICES
extrn _CVXD_Get_Version:near
endif

extrn _VSAUTHD_VMAPI@12:near
extrn _VSAUTHD_PMAPI@12:near
;===========================================================================
;
;   PROCEDURE: CVXD_Control
;
;   DESCRIPTION:
;    Device control procedure for the CVXD VxD
;
;   ENTRY:
;    EAX = Control call ID
;
;   EXIT:
;    If carry clear then
;        Successful
;    else
;        Control call failed
;
;   USES:
;    EAX, EBX, ECX, EDX, ESI, EDI, Flags
;
;============================================================================

BeginProc CVXD_Control
  Control_Dispatch SYS_DYNAMIC_DEVICE_INIT, VSAuthD_Dynamic_Init, sCall
  Control_Dispatch SYS_DYNAMIC_DEVICE_EXIT, VSAuthD_Dynamic_Exit, sCall
  Control_Dispatch W32_DEVICEIOCONTROL,VSAuthD_W32_DeviceIOControl, sCall, <ecx, ebx, edx, esi>
  clc ; return happy value
  ret
EndProc CVXD_Control

; *************************************************************************
; this routine handles api calls made from V86 mode programs.
; It is assumed that the function number is passed
; in eax and any additional parameters are passed in ebx and ecx.
; The C code will do a SWITCH on the eax value to determine which routine to
; call and what parameters to pass.  It is assumed that all functions return
; a value in eax.

BeginProc VSAUTHD_VM
  scall   VSAUTHD_VMAPI, <[ebp].Client_EAX, [ebp].Client_EBX, [ebp].Client_ECX>
  mov    [ebp].Client_EAX,eax    ; put return code
  ret
EndProc    VSAUTHD_VM

; *************************************************************************
; this routine handles 16-bit api calls made from protected mode programs.
; It is assumed that the function number is passed in eax and any additional
; parameters are passed in ebx and ecx.
; The C code will do a SWITCH on the eax value to determine which routine to
; call and what parameters to pass.  It is assumed that all functions return
; a value in eax.

BeginProc  VSAUTHD_PM
  scall   VSAUTHD_PMAPI, <[ebp].Client_EAX, [ebp].Client_EBX, [ebp].Client_ECX>
  mov     [ebp].Client_EAX,eax   ; put return code
  ret
EndProc    VSAUTHD_PM

; *************************************************************************
VxD_LOCKED_CODE_ENDS
;///////////////////////////////////////////////////////////////////////////////
;
; Real Mode Init segment: If this VxD is statically loaded a message
; will appear in Real Mode before windows is started.
;
VxD_REAL_INIT_SEG

Load_Success_Msg  DB  'DOW Parallel Port VxD for Windows 95',13,10
                  DB  'Copyright 1995, Dallas Semiconductor',13,10,13,10
                  DB  'Initialization Complete',13,10
Load_Msg_Len      EQU $ - Load_Success_Msg
;///////////////////////////////////////////////////////////////////////////////
BeginProc CVXD_Real_Init

  jmp NoMessage   ; <-- kill if message is to be displayed
                                      ; This message is displayed
  mov    ah, 40h                      ; soon after autoexec.bat is
  mov    bx, 1                        ; executed but before the GUI
  mov    cx, Load_Msg_Len             ; comes up. It verifies loading
  mov    dx, OFFSET Load_Success_Msg  ; but kills the splash that is
  int    21h                          ; displayed as Windows 95 is
                                      ; initializing.
NoMessage:
  xor    bx, bx
  xor    si, si
  xor    edx, edx
  mov    ax, Device_Load_Ok
  ret

EndProc CVXD_Real_Init
;///////////////////////////////////////////////////////////////////////////////
VxD_REAL_INIT_ENDS
END CVXD_Real_Init

